# MosaicSuite

## Description
Several of the image-processing algorithms developed at the [MOSAIC Group](https://sbalzarini-lab.org) for fluorescence microscopy are available as plugins for the popular free image processing software ImageJ2 or Fiji.
The first plugin which is now part of MosaicSuite was a popular 2D/3D single-particle tracking tool which can be used to track bright spots in 2D/3D movies over time. As more plugins have been added, we decided to provide them in a single, coherent package, which will also group them under a common menu point `Plugins->Mosaic` in ImageJ2 and Fiji.

NOTE: MosaicSuite is still maintained to be bug free but it is not anymore under development so new features or plugins will not be added anymore.


## Documentation
All information about MosaicSuite like:
- installation procedure 
- tutorials 
- latest news
- development 
- useful macros
- and more!

is now available in newly created [MosaicSuite Online Documentation](https://sbalzarini-lab.org/MosaicSuiteDoc/index.html)

It is also accessible directly from ImageJ/Fiji menu:

![MosaicSuite Documentation](https://sbalzarini-lab.org/images/MosaicSuiteDocumentation.png "MosaicSuite Documentation") 


## Disclaimer
*IN NO EVENT SHALL THE MOSAIC GROUP BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE MOSAIC GROUP HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. THE MOSAIC GROUP SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE MOSAIC GROUP HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.*

